`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:19:30 05/19/2016 
// Design Name: 
// Module Name:    freq_div 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module freq_div(
   clk_ctl,
	clk_out,
	clk, 
	rst_n
   );

	output clk_out; // divided clock output
	output [1:0] clk_ctl; // divided clock for seven-segment display scan
	input clk; // clock from the crystal
	input rst_n; // low active reset

	reg clk_out; // divided clock output (in the always block)
	reg [1:0] clk_ctl; // divided clock for seven-segment display scan (in the always block)
	reg [14:0] cnt_l; // temperatory buffer
	reg [6:0] cnt_h; // temperatory buffer
	reg [24:0] cnt_tmp; // input node to flip flops

	// Combinational block : increase by 1 neglecting overflow
	always @(clk_out or cnt_h or cnt_l or clk_ctl)
	  cnt_tmp = {clk_out,cnt_h,clk_ctl,cnt_l} + 1'b1;

	// Sequential block 
	always @(posedge clk or negedge rst_n) 
	  if (~rst_n) 
		 {clk_out,cnt_h,clk_ctl,cnt_l} <= 25'b0; 
	  else 
		 {clk_out,cnt_h,clk_ctl,cnt_l} <= cnt_tmp;



endmodule
